classdef MonteCarlo
    properties
        discount % discount factor
        env % environment structure object
        Q % Q table for all (s,a) pairs
        visits % Visit table for all (s,a) pairs
        optQ % optimal Q values
    end
    methods
        function obj = MonteCarlo(env, discount, initQ, optQ)
            % initQ: initial Q values
            obj.env = env;
            obj.discount = discount;
            obj.Q = initQ*ones(env.snum, env.anum);
            obj.visits = zeros(env.snum,env.anum);
            obj.optQ = optQ;
        end
        function [obj, evalHistory] = learning(obj,TH)
            %TH : The number of total episodes
            t = 0; % count the number of episodes
            evalCount = [];
            evalReward = [];
            while(t < TH)
                % Implement your code here.
                
                % evaluation:
                if mod(t,TH/100) == 0
                    [eval_counts, eval_rewards] = greedy_eval(obj, 30);
                    evalCount = [evalCount, eval_counts];
                    evalReward = [evalReward, eval_rewards];
                    Q_err = [Q_err, rmse(obj.Q, opj.optQ)];
                end
            end
            evalHistory = [evalCount; evalReward; Q_err];
        end
    end
end