%% Policy Iteration

classdef PolicyIteration
    properties
        env % Environment structure for object
        origSlipProb % Slip Probability
        discount % Discount rate
        valueTable % Value table for states
        policyTable % Policy table for states
        theta % Policy evaluation threshold
    end
    methods
        function obj = PolicyIteration(env, discount, theta)
            obj.env = env;
            obj.origSlipProb = obj.env.slipProb;
            % Set to no slip
            obj.env = obj.env.setSlipProb(0);
            obj.discount = discount;
            obj = obj.createValueTable();
            obj = obj.createPolicyTable();
            obj.theta = theta;

        end
        function obj = createValueTable(obj)
            % Initialize values to 0
            obj.valueTable = zeros(obj.env.snum,1);

        end
        function obj = createPolicyTable(obj)
            % Initialize random deterministic policy
            obj.policyTable = ceil(rand(obj.env.snum,1)*obj.env.anum); 
        end
        function [obj, delta] = policyEvaluation(obj)
            % Fill this in
        end
        function [obj, stable] = policyImprovement(obj)
            % Fill this in
        end
        function obj = policyIteration(obj)
            i=0;
            stable = 0;
            while stable == 0
                [obj, delta] = obj.policyEvaluation();
                [obj, stable] = obj.policyImprovement();
                i = i + 1
            end
        end
    end
end