%% Test script
% Template code has been provided
% You will need to fill out the remaining functions in
% 1) maze.m (simulation)
% 2) PolicyIteration.m (policy iteration)
% 3) MonteCarlo.m (monte carlo)
% 4) Qlearning.m (q-learning)

discount_rate = 0.95;
TH = 1000; % The total number of episodes in learning
env = maze();
%% Policy Iteration
pi_threshold = 0.0001;
PI = PolicyIteration(env, discount_rate, pi_threshold);
PI = PI.policyIteration();
% store Q values as optQ

%% Monte Carlo
env = env.reset();
MC = MonteCarlo(env, discount_rate, initQ, optQ);
[MC, evalMC] = MC.learning(TH);
% plot your averaged evaluation results

%% Q-Learning
env = env.reset();
alpha = 0.1;
QL = Qlearning(env, discount_rate, alpha, initQ, optQ);
[QL, evalQL] = QL.learning(TH);
% plot your averaged evaluation results
